
******    Program 3.11: Generation of 10,000 Random Stock Prices   *******;

**************************************************************************;
DATA RNDPRICE;
     DO I=1 TO 10000;
        PRICE=EXP(3.52918406+0.65656975*RANNOR(123));
        PRICE=ROUND(PRICE,1/16);   *** round the price to the closest 1/16.;
        PRICERND=ROUND(PRICE,1);
        OUTPUT;
     END;
PROC UNIVARIATE DATA=RNDPRICE;
     VAR PRICE;
     RUN;
PROC FREQ DATA=RNDPRICE;
     TABLE PRICERND / OUT=FREQHIST(RENAME=(PRICERND=PRICE)
                                   KEEP=PRICERND PERCENT);
     RUN;

/* create the theoretical probability density  */
/* function of stock prices as of 31/1/1999.   */

DATA PDFLOGN;
     DO PRICE=0 TO 200 BY 0.1;
        PROB=100*PDF('LOGNORMAL',PRICE,3.52918406,0.65656975);
        OUTPUT;
     END;
DATA BOTH;
     SET PDFLOGN FREQHIST;
     RUN;
PROC GPLOT DATA=BOTH;
     PLOT (PROB PERCENT)*PRICE / OVERLAY VAXIS=AXIS1
                                 HAXIS=AXIS2;
     AXIS1 LABEL=(A=90 R=0 F=SWISS H=1.5 'Probability (%)')
           ORDER=0 TO 2.5 BY 0.5 VALUE=(H=1.2 F=SWISS)
           MINOR=(N=1);
     AXIS2 LABEL=(F=SWISS H=1.5 'Stock Price ($)')
           ORDER=0 TO 200 BY 25 VALUE=(H=1.2 F=SWISS)
           MINOR=(N=3);
     SYMBOL1 I=JOIN C=BLACK W=1 R=1;
     SYMBOL2 I=STEPCJ C=BLACK W=2 R=1;
     TITLE F=SWISS H=1.5 'Theoretical and Randomly Generated
           Distributions of Stock Prices';
     TITLE2 F=SWISS H=1.5 'Size of Random Sample is 10,000';
     RUN;
     QUIT;
************************************************************************;

