** Program 3.6:  Macro SEEDGEN;

/*******************************************************/
/* Macro SEEDGEN generates seed values to produce      */
/* non-overlapping streams of random numbers.          */
/*                                                     */
/* Parameters                                          */
/* FSSED   first seed                                  */
/* LSTREAM the length of the non-overlapping streams   */
/* NSEEDS  the number of seed values requested         */
/*                                                     */
/* Note                                                */
/* 1. Each paramater must be a positive integer less   */
/*    than 2**31-1.                                    */
/* 2. The macro may generate less number of seeds, if  */
/*    LSTREAM*NSEEDS>2**31-1.                          */
/*                                                     */
/*******************************************************/
%MACRO SEEDGEN(FSEED=,LSTREAM=,NSEEDS=);
   DATA TEMP(KEEP=SEED);
        RETAIN SEED &FSEED;
        OUTPUT;
        DO I=1 TO MIN((&NSEEDS-1)*&LSTREAM,2**31-1) BY &LSTREAM;
           DO J=1 TO &LSTREAM;
              CALL RANUNI(SEED,X);
           END;
           OUTPUT;
        END;
        RUN;
   PROC PRINT DATA=TEMP;
        TITLE "List of &NSEEDS Seed Values";
        TITLE2 "Apart by &LSTREAM Numbers";
        RUN;
%MEND;
***********************************************************;