
**********************************************************************;
***** Program 4.10  PROC IML ***********;
***** Converting a correlation matrix to covariance matrix, and vice versa;
***** Example data from Table 4.4   ;

       ****** Part I: Converting a correlation matrix to a covariance matrix;
PROC IML;
          *** define the correlation matrix; 
R={1.00 0.70 0.20,
   0.70 1.00 0.40,
   0.20 0.40 1.00};

          *** define the diagonal matrix with standard deviations on the diagonal ;
S={15  0  0,
    0 10  0,
    0  0  1};

COV=S*R*S;     *** obtain the covariance matrix;

PRINT COV;     *** print the covariance matrix;

RUN;


      ***** Part II: Converting a covariance matrix to correlation matrix;
PROC IML;

COV={225 105 3,
     105 100 4,
       3   4 1};

S=SQRT(DIAG(COV));   *** obtain the matrix with standard deviations on the diagonal;

S_INV=INV(S);        *** the inverse of S matrix;

R=S_INV*COV*S_INV;   *** obtain correlation matrix;

PRINT COV;           *** print out the three matrices;
PRINT S;
PRINT R;
RUN;

