
*****   Program 4.5a Generating Three Correlated Normal Variables  *****;
DATA A (TYPE=CORR);  _TYPE_='CORR';  
  INPUT X1-X3;
CARDS;
1.00  .    .
 .70 1.00  .
 .20  .40 1.00
;

    * obtain factor pattern matrix for later data generation;

PROC FACTOR N=3 OUTSTAT=FACOUT; 
DATA PATTERN; SET FACOUT;
  IF _TYPE_='PATTERN';
  DROP _TYPE_ _NAME_;
RUN;

PROC IML;                          
   USE PATTERN;                   * read in the factor pattern as a matrix 'F';
   READ ALL VAR _NUM_ INTO F;
  F=F`;           

DATA=RANNOR(J(10000,3,0));    *** generate data matrix (10000x3);
DATA=DATA`;                   *** transpose data matrix (3x10000);
Z = F*DATA;                   *** impose inter-correlations;
Z = Z`;                       *** transpose data matrix back (10000x3);

X1=Z[,1]*15 + 100;            *** linear transformation for specified mean and std;
X2=Z[,2]*10 + 50;
X3=Z[,3];
  *** output data to a SAS working data 'A';
Z=X1||X2||X3;
CREATE A FROM Z [COLNAME={X1 X2 X3}];
APPEND FROM Z;
      *** obtaining sample descriptive statistics;
PROC MEANS DATA=A N MEAN STD SKEWNESS KURTOSIS;
  VAR X1 X2 X3;
PROC CORR DATA=A NOSIMPLE;
  VAR X1 X2 X3;
RUN;
************************************************************************;
