
****  Program 4.9:  Generate Sample of Non-Normal Multivariate Data  ****;
DATA A (TYPE=CORR);  _TYPE_='CORR';  
  INPUT X1-X3;
CARDS;
1.0000  .    .
 .7402 1.0000  .
 .2054  .4173 1.0000
;

    * obtain factor pattern matrix for later data generation;

PROC FACTOR N=3 OUTSTAT=FACOUT; 
DATA PATTERN; SET FACOUT;
  IF _TYPE_='PATTERN';
  DROP _TYPE_ _NAME_;
RUN;

PROC IML;                          
   USE PATTERN;                   * read in the factor pattern as a matrix 'F';
   READ ALL VAR _NUM_ INTO F;
  F=F`;           

DATA=RANNOR(J(10000,3,0));    *** generate data matrix (100003);
DATA=DATA`;                   *** transpose data matrix (310000);
Z = F*DATA;                   *** impose inter-correlations;
Z = Z`;                       *** transpose data matrix back (100003);

                                        * Fleishman non-normality transformation;

X1 = -.124833577 + .978350485*Z[,1] + .124833577*Z[,1]##2 + .001976943*Z[,1]##3;
X2 =  .124833577 + .978350485*Z[,2] - .124833577*Z[,2]##2 + .001976943*Z[,2]##3;
X3 = -.096435287 + .843688891*Z[,3] + .096435287*Z[,3]##2 + .046773413*Z[,3]##3;

X1=X1*15 + 100;                         * linear transformation for mean & std;
X2=X2*10 + 50;
X3=X3;
Z=X1||X2||X3;
CREATE A FROM Z [COLNAME={X1 X2 X3}];   * output a SAS working data 'A';
APPEND FROM Z;

                                        * obtaining descriptive stats for sample data;
PROC MEANS DATA=A N MEAN STD SKEWNESS KURTOSIS;
  VAR X1 X2 X3;
PROC CORR DATA=A NOSIMPLE NOPROB;
  VAR X1 X2 X3;
RUN; QUIT;
*******************************************************************;
