
***********   Program 5.1: Matching Birthdays   *******************;
DATA RESULTS;

     /* array of day indicators. A value of one in an element of this array  */
     /* indicates the selection of that birthday. Zero means that birthday   */
     /* has not been selected.                                               */

     ARRAY DAYS(365) $1 D1-D365;
     LENGTH NPEOPLE 3;
     DO SIM=1 TO 10000;  *** execute 10,000 simulations of the problem.;
        DO I=1 TO 365;
           DAYS(I)='0';  *** the day indicators are set to zero initially.;
        END;
        DO NPEOPLE=1 TO 366;
           D=1+INT(365*RANUNI(123));   *** generate a random birthday between 1 and 365.;
           IF DAYS(D)='1' THEN LEAVE;  *** was that birthday previously selected-;
                                       *** if yes, leave the loop.;
                          ELSE DAYS(D)='1';  *** If not, mark the day as 'selected'.;
        END;
        OUTPUT;
     END;
     RUN;

/* check the distribution of all birthdays selected during the simulation. */
/* they should form a uniform distribution between 1 and 365. Place each   */
/* birthday into an individual observation.                                */

DATA DAY(KEEP=DAY);
     SET RESULTS;
     ARRAY DAYS(365) D1-D365;
     DO I=1 TO 365;
        IF DAYS(I)='1' THEN DO; DAY=I;
                                OUTPUT; END;
     END;
     RUN;

/* test whether or not the days generated randomly follow the uniform  */
/* distribution between 1 and 365. Use PROC CAPABILITY with the 'beta' */
/* distribution, because the uniform distribution is a special beta    */
/* distribution (alpha=beta=1). Set the threshold and scale parameters */
/* to 1 and 365 respectively.                                          */

PROC CAPABILITY DATA=DAY;
     VAR DAY;
     QQPLOT DAY / BETA (ALPHA=1 BETA=1 THETA=1 SIGMA=365)
                  HAXIS=AXIS1 VAXIS=AXIS2 NOLEGEND;
     AXIS1 LABEL=(F=SWISS H=1.5 'Uniform Distribution (1-365)')
           ORDER=0 TO 1 BY 0.2 VALUE=(H=1.2 F=SWISS) MINOR=(N=1);
     AXIS2 LABEL=(A=90 R=0 F=SWISS H=1.5 'Random Birthday')
           ORDER=0 TO 400 BY 100 VALUE=(H=1.2 F=SWISS) MINOR=(N=1);
     TITLE  F=SWISS H=1.5 'Q-Q Plot of Randomly Selected Birthdays';
     SYMBOL1 R=8;
     SYMBOL9 I=JOIN C=BLACK W=40;
     RUN;
PROC UNIVARIATE DATA=RESULTS PLOT;   *** calculate and present the answer.;
     VAR NPEOPLE;
     RUN;
*****************************************************************************;
