
**********   Program 5.3  Macro Solution of the Matching Birthdays ***********;

***  Original Solution ********;
DATA RESULTS(KEEP=NPEOPLE);
     ARRAY DAYS(365) $1 D1-D365;
     LENGTH NPEOPLE 3;
     DO SIM=1 TO 10000;

       IF NOT MOD(SIM,2000) THEN PUT
          'SIMULATION NUMBER: ' SIM;
       DO I=1 TO 365;
         DAYS(I)='0';
       END;
       DO NPEOPLE=1 TO 366;
          D=1+INT(365*RANUNI(123));
           IF DAYS(D)='1' THEN LEAVE;
                     ELSE DAYS(D)='1';
       END;
       OUTPUT;
     END;
     RUN;
PROC UNIVARIATE DATA=RESULTS PLOT;
     VAR NPEOPLE;
     RUN;


****  Macro Solution  *************;
/*****************************************/
/* Macro BDAY simulates the problem of   */
/* of Matching Birthdays.                */
/*                                       */
/* Parameters:                           */
/* NDAYS   # of days in a year.          */
/* NSIMS   # of simulations.             */
/* MSG     # of simulations at which to  */
/*         display a message in the LOG  */
/*         window to monitor the run.    */
/* SEED    Seed of function RANUNI.      */
/* OUT     the name of the file that     */
/*         captures the results.         */
/*****************************************/
%MACRO BDAY(NDAYS=365,NSIMS=10000,MSG=2000,
            SEED=0,OUT=RESULTS);
DATA &OUT(KEEP=NPEOPLE);
     ARRAY DAYS(&NDAYS) $1 D1-D&NDAYS;
     LENGTH NPEOPLE 3;
     DO SIM=1 TO &NSIMS;
        %IF &MSG^=0 %THEN %DO;
        IF NOT MOD(SIM,&MSG) THEN PUT
              'SIMULATION NUMBER: ' SIM;
                          %END;
        DO I=1 TO &NDAYS;
           DAYS(I)='0';
        END;        
        DO NPEOPLE=1 TO &NDAYS+1;
           D=1+INT(&NDAYS*RANUNI(&SEED));
           IF DAYS(D)='1' THEN LEAVE;
                          ELSE DAYS(D)='1';
        END;
        OUTPUT;
     END;
     RUN;
PROC UNIVARIATE DATA=&OUT PLOT;
     VAR NPEOPLE;
     RUN;
%MEND;
%BDAY(SEED=123)