
****************      Program 5.4:       *************************************;
*****  Macro Solution of the Matching Birthdays with Full Time Monitoring ****;

LIBNAME MYMACLIB 'subdirectory';   *** define a location for the macro library.;
OPTION SASMSTORE=MYMACLIB MSTORED;

/* Macro TMONST starts the time monitoring.                    */
/* Parameter                                                   */
/* MSG       # of simulations at which the program displays a  */
/*           a message in the LOG window. Specify zero, if you */
/*           wish to suppress the monitoring.                  */

%MACRO TMONST(MSG=2000) / STORE;
  _MSGCNT=0;
  %IF &MSG^=0 %THEN %DO;
      _MSGCNT=&MSG;
      _SDT=DATETIME();
      _STIME=TIMEPART(_SDT);
      PUT 'Starting Time: ' _STIME TIME12.3;
      LENGTH _MSG $72;
      SUBSTR(_MSG,1,13)='Simulation #:';
      SUBSTR(_MSG,21,16)=', Current Time: ';
      SUBSTR(_MSG,49,16)=', Duration: ';
  %END;
%MEND;

/* macro TMON displays the simulation number, current time and */
/* elapsed time after a certain number of simulations.         */

%MACRO TMON / STORE;
  IF _MSGCNT^=0 THEN DO;
      _SIM+1;
      IF NOT MOD(_SIM,_MSGCNT) THEN DO; _EDT=DATETIME();
                                        _ETIME=TIMEPART(_EDT);
                                        _DUR=_EDT-_SDT;
                                        SUBSTR(_MSG,15,6)=PUT(_SIM,6.);
                                        SUBSTR(_MSG,37,12)=PUT(_ETIME,TIME12.3);
                                        SUBSTR(_MSG,61,12)=PUT(_DUR,TIME12.3);
                                        PUT _MSG;
                                        _SDT=_EDT;
                                    END;
                     END;
%MEND;

/* a new SAS session starts here. */

LIBNAME MYMACLIB 'subdirectory';   *** this is the location of the macro library.;
OPTION SASMSTORE=MYMACLIB;
%MACRO BDAY(NDAYS=365,NSIMS=10000,MSG=2000, SEED=0,OUT=RESULTS);
  DATA &OUT(KEEP=NPEOPLE);
       ARRAY DAYS(&NDAYS) $1 D1-D&NDAYS;
       LENGTH NPEOPLE 3;
       %TMONST(MSG=2000)
       DO SIM=1 TO &NSIMS;
          %TMON
          DO I=1 TO &NDAYS;
             DAYS(I)='0';
          END;
          DO NPEOPLE=1 TO &NDAYS+1;
             D=1+INT(&NDAYS*RANUNI(&SEED));
             IF DAYS(D)='1' THEN LEAVE;
                            ELSE DAYS(D)='1';
          END;
          OUTPUT;
       END;
       RUN;
  PROC UNIVARIATE DATA=&OUT PLOT;
       VAR NPEOPLE;
       RUN;
%MEND;
%BDAY(SEED=123)
