
************   Program 5.6: One Simulation of Parking  ***********;

***************************************************************;
%PARKING(OUT=ONESIM,LEVEL=PARKING,KEEP=ALL)
PROC PRINT DATA=ONESIM;
     FORMAT P1-P12 5.3;
     TITLE F=SWISS H=1.5 'One Random Parking (Street=10, Car=1)';
     RUN;

/* dataset ONESIM contains all parked cars of one simulation. */
/* prepare the dataset for drawing the sequence of parking    */
/* with PROC GPLOT using the SYMBOL INTERPOL=HILOBC;          */
/* statement that draws a rectangle representing a car.       */

DATA ONESIM(KEEP=CARS STREET);
     SET ONESIM;
     ARRAY PRKGLOC(12) P1-P12;
     DO I=2 TO _N_+1;

        /* make the 'x' coordinate of each car unique by      */
        /* adding a unique fudging factor to each.            */

        CARS=_N_+0.00000001*I;
        STREET=PRKGLOC(I)+0.5; OUTPUT;
        STREET=PRKGLOC(I)-0.5; OUTPUT;

        /* create two 'y' values in order to have the         */
        /* vertical sides of the rectangle.                   */

        STREET=PRKGLOC(I)-0.5; OUTPUT;
     END;
PROC FORMAT;
     VALUE FCARS 0=' ' 8=' ';
PROC GPLOT DATA=ONESIM;
     PLOT STREET*CARS / VAXIS=AXIS1 HAXIS=AXIS2;
     FORMAT CARS FCARS.;
     SYMBOL INTERPOL=HILOBC;
     AXIS1 LABEL=(A=90 R=0 F=SWISS H=1.5 'Street')
           ORDER=0 TO 10 BY 1 VALUE=(H=1.2 F=SWISS) MINOR=NONE;
     AXIS2 LABEL=(F=SWISS  H=1.5 'Cars')
           ORDER=0 TO 8 BY 1 VALUE=(H=1.2 F=SWISS) MINOR=NONE;
RUN;
************************************************************************;
