
******  Program 5.8: Approximation of the Rnyi's Constant  ************;
%PARKING(OUT=RES10,STRLNGTH=10,NSIMS=100000)
%PARKING(OUT=RES100,STRLNGTH=100,NSIMS=100000)
%PARKING(OUT=RES1000,STRLNGTH=1000,NSIMS=100000)
%PARKING(OUT=RES10000,STRLNGTH=10000,NSIMS=10000)
DATA RESALL;   *** concatenate the results of all simulations;
     SET RES10(IN=S10)     RES100(IN=S100)
         RES1000(IN=S1000) RES10000(IN=S10000);
     IF S10    THEN STREET=10;  *** set up the length of the street.;
     IF S100   THEN STREET=100;
     IF S1000  THEN STREET=1000;
     IF S10000 THEN STREET=10000;
PROC MEANS DATA=RESALL NOPRINT;  *** calculate average number of cars.;
     VAR NCARS STREET;
     BY STREET;
     OUTPUT OUT=RENYI(KEEP=RENYI STREET NSIMS) MEAN=RENYI N=NSIMS;
     RUN;
DATA RENYI;   *** calculate the Renyi's constant (average number of.;
              *** cars over the length of the street).;
     SET RENYI;
     RENYI=RENYI/STREET;
     RUN;
PROC PRINT DATA=RENYI LABEL SPLIT='*' NOOBS;
     VAR STREET RENYI NSIMS;
     LABEL STREET='Length of*Street' RENYI="Renyi's*Constant"
           NSIMS='Number of*Simulations';
     TITLE  "Approximation of the Renyi's Constant";
     TITLE2 "(Average Number of Cars / Length of Street)";
     RUN;
**************************************************************************;
