/************************************************************************************/
/* This program generates a series of 50 observations with an AR1 process.  The	*/
/* expected AR1 value will be .8367, the square of which is .70.  The error	*/
/* variance component is made to account for 30% of each total observation variance	*/
/*(with the exception of the most recent observation in the series).	*/
/*	*/
/************************************************************************************/

DATA AR;
      ARRAY OBS OBS1-OBS50;   *** Room is made for 50 observations;

  OBS (1) = RANNOR (-1);   *** The most recent observation in the series;
    DO J = 2 TO 50;
        OBS (J) = SQRT(.70) * OBS (J-1) + SQRT(.30) * RANNOR(-1);
    END; OUTPUT;
         KEEP OBS1-OBS50; 
  PROC TRANSPOSE OUT=AR1;   *** The series is transposed into a column for PROC ARIMA;

DATA AR1; SET AR1;

PROC ARIMA DATA = AR1; IDENTIFY VAR=COL1 NLAG=1;  *** The AR1 lag value is estimated;
           ESTIMATE P = 1;
RUN;
*************************************************************************************;
