/************************************************************************************/
/* This program generates three series (Series A, B, and C) of 200 observations     */
/* each with a Multivariate AR1 process with cross lagged relationships.  The       */
/* Autoregressive coefficients for each series are .80, .60, and .45, respectively, */
/* and the error variance components are .20, .20 and .15, respectively.  The cross */
/* lagged relationships between Series A and B is .20; between Series A and C, .10; */
/* and between Series B and C, .30.                                                */
/*                                                                                  */
/************************************************************************************/

DATA GENERATE;
  ARRAY SERIEA SERIEA1-SERIEA200;          *** each creates room for 200 observations;
  ARRAY SERIEB SERIEB1-SERIEB200;
  ARRAY SERIEC SERIEC1-SERIEC200;
  ARRAY VAR_A  VAR_A1 -VAR_A200;
  ARRAY VAR_B  VAR_B1 -VAR_B200;
  ARRAY VAR_C  VAR_C1 -VAR_C200;

  SERIEA(1)=RANNOR(-1);                    *** generates the first occasion;
  SERIEB(1)=RANNOR(-11);
  SERIEC(1)=RANNOR(-111);

       VAR_A(1) =0;
       VAR_B(1) =0;
       VAR_C(1) =0;

    DO J=2 TO 200;

       VAR_A(J) =RANNOR(-1111);  *** random normal deviates are generated;
       VAR_B(J) =RANNOR(-11111);
       VAR_C(J) =RANNOR(-111111);

                                 *** the equations which generate the process follows;
SERIEA(J)=VAR_A(J)*SQRT(.20) + SERIEA(J-1)*SQRT(.80);
SERIEB(J)=VAR_B(J)*SQRT(.20) + SERIEB(J-1)*SQRT(.60) + SERIEA(J-1)*(.20);
SERIEC(J)=VAR_C(J)*SQRT(.15) + SERIEC(J-1)*SQRT(.45) + SERIEA(J-1)*(.10) +
          SERIEB(J-1)*(.30);

    END;KEEP SERIEA1-SERIEA200
             SERIEB1-SERIEB200
             SERIEC1-SERIEC200;  *** retains only the series generated;
OUTPUT;
****************************************************************************;
